#include <iostream.h>
#include "file.h"


void interpret(FILE* f)
{
    extern FILE* yyin;
    extern int include_stack_ptr;
    extern int yyparse();
    extern void yyrestart(FILE*);

    /*
	Kind of an experimental kludge to make this routine work.
     */

    if (!include_stack_ptr) {
	yyin = f;
	if (yyin == stdin) 
	    cout << "\rClassic> " << flush;
    }

    /*
	If we simply put yyrestart(yyin) here, then some input will be
	lost in this situation:

           A file has a statement that calls a procedure.  That
	   procedure called evaluate.  Then, when evaluate returns,
	   there will be some data loss.

        If we do not put yyrestart(yyin) at all, then it won't work 
	after initial loading of files.  The user input is ignored.
     */

    if (yyin == stdin)
	yyrestart(yyin);

    yyparse();
}


bool load_file(const char* filename)
{
    extern void init_load(const char*);
    extern void load(const char*);
    static bool first = TRUE;

    if (first) {
	first = FALSE;
	init_load(filename);
    } else
	load(filename);

    return TRUE;
}
