#include "object_base.h"
#include "rule_base.h"
#include "concept.h"
#include "individual.h"
#include "role.h"
#include "expression.h"
#include "file.h"
#include "trace.h"

ObjectBase OB;
ObjectBase& Object::object_base = OB;
RuleBase RB;

Concept*& Thing = OB.thing;
Concept*& ClassicThing = OB.classic_thing;
Concept*& HostThing = OB.host_thing;
Concept*& NumberThing = OB.number_thing;
Concept*& StringThing = OB.string_thing;
Concept*& Integer = OB.integer;
Concept*& Float = OB.floating;


void print_object(char* s)
{
    Object* obj = object(s);
    if (!obj)
	cout << "no such object" << endl;
    else
	obj->print();
}


void user()
{
    Role* name = define_attribute("name");
    Concept* IDENTIFIER = define_primitive("IDENTIFIER", 
			      all(name, StringThing));
    Concept* FILENAME = define_concept("FILENAME", 
			      test_c("filename?", name, 0));
    Concept* HIDDEN_FILENAME = define_concept("HIDDEN-FILENAME",
			      and(FILENAME, 
				  test_c("strprefix", name, ind("."), 0), 
				  0));
    Concept* RELNAME = define_concept("RELNAME", 
			      and(IDENTIFIER, 
				  test_c("relname?", name, 0),
				  0));
}


main(int argc, char** argv)
{
    extern void declare();
    declare(); 

    while (argv++, --argc) {
	load_file(*argv);
    }
 
//    user();

    while (!feof(stdin)) {
	interpret();
    }
    return 0;
}
