#if !defined(RULE_BASE_H)
#define RULE_BASE_H

class RuleBase {

/*
    The RuleBase is a collection of rules.  Each rule is of the form

	rule_name: antecedent_concept -> consequent_concept

    The RuleBase also contains two maps:

	antecedent_map: Concept* -> Rule* Rule* ...
	consequent_map: Concept* -> Rule* Rule* ...
 */

public:

    RuleBase() {}

   ~RuleBase() {}
    
    void insert(Rule*);

    void fire(Concept*, Individual*);

    List<Rule*> forward_rules(Concept*) const;

    List<Rule*> indirect_rules(Concept*) const;

    List<Rule*> backward_rules(Object*) const;

private:

    List<Rule*> _rules;    // kind of redundant, but ... keep it for now.

    MultiMap<Concept*, Rule*> _antecedent_map;

    MultiMap<Object*, Rule*> _consequent_map;
};

extern RuleBase RB;

#endif
