
/*  A Bison parser, made from parse.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	INTEGER	258
#define	UNSIGNED	259
#define	REAL	260
#define	STRING	261
#define	ID	262
#define	COMMAND	263
#define	CMD_DEF_CON	264
#define	CMD_DEF_PRIM	265
#define	CMD_DEF_DISJ_PRIM	266
#define	CMD_DEF_IND	267
#define	CMD_DEF_ROLE	268
#define	CMD_DEF_ATTR	269
#define	CMD_DEF_RULE	270
#define	CMD_AND	271
#define	CMD_ALL	272
#define	CMD_FILLS	273
#define	CMD_ONE_OF	274
#define	CMD_AT_LEAST	275
#define	CMD_AT_MOST	276
#define	CMD_EXACTLY	277
#define	CMD_BETWEEN	278
#define	CMD_TEST_C	279
#define	CMD_COMPUTED_CONCEPT	280
#define	CMD_COMPUTED_FILLERS	281
#define	CMD_CLOSE_ROLE	282
#define	CMD_IND_ATTR_FILLER	283
#define	CMD_IND_ROLE_FILLERS	284
#define	CMD_IND_PARENTS	285
#define	CMD_CON_PARENTS	286
#define	CMD_LOAD	287
#define	CMD_TRACE	288
#define	CMD_UNTRACE	289
#define	CMD_ECHO	290
#define	CMD_NTH	291
#define	OP_CLASS	292
#define	OP_SUB	293
#define	OP_RULE	294
#define	OP_TEST	295
#define	OP_ON	296
#define	OP_OFF	297
#define	OP_LE	298
#define	OP_GE	299

#line 1 "parse.y"

#define YYDEBUG 1

/*
    I don't know if this is a bug or what.  #include "trace.h" must be
    put in this position (first of all #include's).  If it is below
    iostream.h and stdlib.h then there will be a linking error.  

    Possibly some name clashes or typedef clashes in stdlib.h or
    iostream.h.
 */

#include "trace.h"
#include <iostream.h>
#include <stdlib.h>
#include "individual.h"
#include "concept.h"
#include "expression.h"
#include "classify.h"

extern void print_object(char*);
extern void load(const char*);
extern int yyerror(char* s);
extern int yylex();
extern int lineno[];
extern int include_stack_ptr;
extern bool eval;

/*
    When there are nested "and" statements like so:

    (and C1 
	 C2 
	 (and C3 ...))

    Then, we need to keep more than one list of concepts in 
    concept_expr_list.  The first list will consist of 

	C1 C2 <tmp>

    where <tmp> is the second list 

	C3 ...

    The more nested "and" statements, the more tmp lists needed.
    _____________________________________________________________

    Second thought.  Observe that

    (and C1 
	 C2 
	 (and C3 ...))

    is equivalent to 

    (and C1 C2 C3 ...)

    It is quite possible to expand the inner and in Yacc.  This 
    can be done by simply using a single list for all inner ands.
    The only problem is how do we know which and is the outer 
    most, so that we only return an "and" concept for the outer
    most and.  This can be done by a simple counter.
    _____________________________________________________________

    Third thought.  Wrong wrong wrong.  Consider this:

    (and C1 (all R (and X1 ...)))

    This is not equivalent to

    (and C1 X1 ...)
*/

#define MAX_AND 20
static List<Concept*> and_expr[MAX_AND];
static int and_n = 0;

static List<Individual*> fillers;
static List<Individual*> role_fillers;
static List<Concept*> concepts;
static List<Role*> roles;
static ObjectVector objects;


#line 86 "parse.y"
typedef union {
    int integer;
    float real;
    char* string;
    int cmd;
    Concept* concept;
    Individual* individual;
    Object* object;
    ComputedConcept* computed_concept;
    ComputedFillers* computed_fillers;
    List<Individual*>* role_fillers;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		197
#define	YYFLAG		-32768
#define	YYNTBASE	49

#define YYTRANSLATE(x) ((unsigned)(x) <= 299 ? yytranslate[x] : 82)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    46,
    45,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    47,
     2,    48,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
    41,    43,    45,    51,    57,    63,    69,    74,    79,    81,
    83,    85,    87,    89,    95,   101,   103,   105,   107,   109,
   112,   118,   120,   123,   128,   133,   138,   143,   148,   153,
   158,   163,   168,   173,   178,   183,   188,   193,   199,   205,
   207,   209,   216,   222,   229,   236,   243,   249,   254,   256,
   258,   260,   261,   267,   273,   279,   285,   291,   298,   304,
   309,   315,   317,   320,   326,   333,   335,   337,   338
};

static const short yyrhs[] = {    -1,
    49,    50,     0,     1,    45,     0,    51,     0,    52,     0,
    62,     0,    61,     0,    63,     0,    64,     0,    65,     0,
    66,     0,    68,     0,    69,     0,    70,     0,    53,     0,
    71,     0,    72,     0,     7,     0,    55,     0,    56,     0,
    75,     0,    59,     0,    46,    47,     7,    74,    45,     0,
    46,    48,    74,     7,    45,     0,    46,    43,     7,    74,
    45,     0,    46,    44,    74,     7,    45,     0,    46,    30,
    54,    45,     0,    46,    31,    74,    45,     0,     7,     0,
     3,     0,     4,     0,     5,     0,     6,     0,    46,    28,
    57,     7,    45,     0,    46,    36,    59,     4,    45,     0,
    54,     0,    55,     0,    56,     0,    57,     0,    58,    57,
     0,    46,    29,    57,     7,    45,     0,     7,     0,    60,
     7,     0,    46,    32,     7,    45,     0,    46,    32,     6,
    45,     0,    46,    33,    41,    45,     0,    46,    33,    42,
    45,     0,    46,    33,    37,    45,     0,    46,    33,    38,
    45,     0,    46,    33,    39,    45,     0,    46,    33,    40,
    45,     0,    46,    34,    37,    45,     0,    46,    34,    39,
    45,     0,    46,    34,    40,    45,     0,    46,    34,    38,
    45,     0,    46,    13,     7,    45,     0,    46,    14,     7,
    45,     0,    46,     9,     7,    73,    45,     0,    46,    10,
     7,    73,    45,     0,     7,     0,     4,     0,    46,    11,
     7,    73,    67,    45,     0,    46,    12,     7,    73,    45,
     0,    46,    15,     7,    74,    73,    45,     0,    46,    15,
     7,    74,    78,    45,     0,    46,    15,     7,    74,    79,
    45,     0,    46,    27,    54,    60,    45,     0,    46,    35,
    55,    45,     0,    74,     0,    75,     0,     7,     0,     0,
    46,    16,    76,    77,    45,     0,    46,    17,     7,    73,
    45,     0,    46,    21,     4,     7,    45,     0,    46,    20,
     4,     7,    45,     0,    46,    22,     4,     7,    45,     0,
    46,    23,     4,     4,     7,    45,     0,    46,    18,     7,
    58,    45,     0,    46,    19,    58,    45,     0,    46,    24,
     7,    81,    45,     0,    73,     0,    77,    73,     0,    46,
    25,     7,    81,    45,     0,    46,    26,     7,     7,    81,
    45,     0,     7,     0,    55,     0,     0,    81,    80,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   157,   158,   164,   173,   176,   177,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   191,   195,   200,
   208,   216,   226,   236,   246,   253,   262,   273,   286,   295,
   299,   303,   307,   313,   321,   333,   334,   335,   338,   343,
   350,   361,   368,   377,   388,   395,   399,   403,   407,   411,
   415,   419,   423,   427,   431,   437,   446,   455,   464,   473,
   477,   484,   494,   503,   510,   517,   526,   555,   561,   565,
   571,   580,   585,   593,   597,   601,   605,   609,   613,   620,
   626,   635,   640,   646,   655,   664,   673,   679,   680
};

static const char * const yytname[] = {   "$","error","$undefined.","INTEGER",
"UNSIGNED","REAL","STRING","ID","COMMAND","CMD_DEF_CON","CMD_DEF_PRIM","CMD_DEF_DISJ_PRIM",
"CMD_DEF_IND","CMD_DEF_ROLE","CMD_DEF_ATTR","CMD_DEF_RULE","CMD_AND","CMD_ALL",
"CMD_FILLS","CMD_ONE_OF","CMD_AT_LEAST","CMD_AT_MOST","CMD_EXACTLY","CMD_BETWEEN",
"CMD_TEST_C","CMD_COMPUTED_CONCEPT","CMD_COMPUTED_FILLERS","CMD_CLOSE_ROLE",
"CMD_IND_ATTR_FILLER","CMD_IND_ROLE_FILLERS","CMD_IND_PARENTS","CMD_CON_PARENTS",
"CMD_LOAD","CMD_TRACE","CMD_UNTRACE","CMD_ECHO","CMD_NTH","OP_CLASS","OP_SUB",
"OP_RULE","OP_TEST","OP_ON","OP_OFF","OP_LE","OP_GE","')'","'('","'<'","'>'",
"lines","line","command","inspect","concept_list","named_individual","host_individual",
"unnamed_individual","individual","individual_list","role_fillers","role_list",
"load_file","trace","define_role","define_attr","define_concept","define_primitive",
"disj_type","define_disjoint_primitive","define_individual","define_rule","close_role",
"echo","concept_expr","named_concept","unnamed_concept","@1","concept_expr_list",
"computed_concept","computed_fillers","object","object_list",""
};
#endif

static const short yyr1[] = {     0,
    49,    49,    49,    50,    51,    51,    51,    51,    51,    51,
    51,    51,    51,    51,    51,    51,    51,    52,    52,    52,
    52,    52,    52,    52,    52,    52,    53,    53,    54,    55,
    55,    55,    55,    56,    56,    57,    57,    57,    58,    58,
    59,    60,    60,    61,    61,    62,    62,    62,    62,    62,
    62,    62,    62,    62,    62,    63,    64,    65,    66,    67,
    67,    68,    69,    70,    70,    70,    71,    72,    73,    73,
    74,    76,    75,    75,    75,    75,    75,    75,    75,    75,
    75,    77,    77,    78,    79,    80,    80,    81,    81
};

static const short yyr2[] = {     0,
     0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     5,     5,     5,     5,     4,     4,     1,     1,
     1,     1,     1,     5,     5,     1,     1,     1,     1,     2,
     5,     1,     2,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     5,     5,     1,
     1,     6,     5,     6,     6,     6,     5,     4,     1,     1,
     1,     0,     5,     5,     5,     5,     5,     6,     5,     4,
     5,     1,     2,     5,     6,     1,     1,     0,     2
};

static const short yydefact[] = {     0,
     0,     0,     3,    30,    31,    32,    33,    18,     0,     2,
     4,     5,    15,    19,    20,    22,     7,     6,     8,     9,
    10,    11,    12,    13,    14,    16,    17,    21,     0,     0,
     0,     0,     0,     0,     0,    72,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
    36,    37,    38,    39,     0,     0,     0,     0,     0,    88,
     0,     0,     0,     0,    71,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    69,    70,     0,
     0,     0,    56,    57,     0,    82,     0,     0,     0,    80,
    40,     0,     0,     0,     0,     0,    42,     0,     0,     0,
    27,    28,    45,    44,    48,    49,    50,    51,    46,    47,
    52,    55,    53,    54,    68,     0,     0,     0,     0,     0,
    58,    59,    61,    60,     0,    63,     0,     0,     0,     0,
    73,    83,    74,    79,    76,    75,    77,     0,    86,    81,
    87,    89,    43,    67,    34,    41,    35,    25,    26,    23,
    24,    62,     0,     0,    64,    65,    66,    78,    88,     0,
     0,    88,    84,     0,    85,     0,     0
};

static const short yydefgoto[] = {     2,
    10,    11,    12,    13,    71,    72,    73,    74,    75,    16,
   128,    17,    18,    19,    20,    21,    22,   155,    23,    24,
    25,    26,    27,   107,   108,   109,    66,   117,   159,   160,
   172,   126
};

static const short yypact[] = {    20,
   -38,    29,-32768,-32768,-32768,-32768,-32768,-32768,   130,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     5,    41,
    55,    58,    66,    71,    74,-32768,    75,    76,    49,   104,
   117,   118,   119,   120,   148,    49,    49,   148,   149,    70,
    65,    54,   164,    79,   165,   149,   168,   149,     1,     1,
     1,     1,    81,   126,   149,     1,     1,    49,-32768,    36,
-32768,-32768,-32768,-32768,    34,   169,   172,   173,   177,-32768,
   175,   176,   178,   139,-32768,   141,   142,   143,   145,   146,
   150,   151,   152,   153,   154,   155,   156,   157,   158,   179,
   189,   149,   187,   149,   197,   113,   160,-32768,-32768,   161,
    10,   162,-32768,-32768,    11,-32768,     4,   166,    39,-32768,
-32768,   167,   170,   171,   202,    64,-32768,    56,   174,   180,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   181,   182,   183,   184,   185,
-32768,-32768,-32768,-32768,   186,-32768,    94,   188,   190,   191,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   192,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   203,   206,-32768,-32768,-32768,-32768,-32768,   207,
    83,-32768,-32768,    93,-32768,   217,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,   -29,    -2,   216,   -45,   193,   194,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   -57,   -43,   218,-32768,-32768,-32768,-32768,
-32768,  -161
};


#define	YYLAST		261


static const short yytable[] = {    14,
    82,    83,   110,   111,   112,    86,     3,    85,   116,   118,
    85,    59,   103,   153,   105,    81,   154,    85,    84,    -1,
     1,   115,    -1,    -1,    -1,    -1,    -1,   191,   196,   121,
   194,     4,     5,     6,     7,     8,     4,     5,     6,     7,
    69,     4,     5,     6,     7,    69,   106,    60,   161,   106,
    99,     4,     5,     6,     7,    69,   157,   158,   147,   162,
   149,    61,   173,    46,    62,    -1,     4,     5,     6,     7,
   169,    54,    63,   121,     9,    87,    88,    64,   120,    70,
    65,    67,    68,   164,    70,     4,     5,     6,     7,   169,
    95,    96,    97,    98,    70,     4,     5,     6,     7,   169,
   174,    89,    90,    91,    92,    93,    94,    76,   170,    36,
    37,    38,    39,    40,    41,    42,    43,    44,   183,   184,
    77,    78,    79,   171,   100,   113,    80,   193,    36,    37,
    38,    39,    40,    41,    42,    43,    44,   195,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    69,    85,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,     4,     5,     6,     7,
   114,   102,    55,    56,   104,   122,    57,    58,   123,   124,
   125,   127,   129,   131,   130,   132,   133,   134,   171,   135,
   136,   171,   146,   148,   137,   138,   139,   140,   141,   142,
   143,   144,   145,   150,   151,   152,   156,    47,   168,   189,
   163,   165,   190,   192,   166,   167,   197,    15,   175,    28,
     0,     0,     0,     0,   176,   177,   178,   179,   180,   181,
   182,     0,   185,     0,   186,   187,   188,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   101,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   119
};

static const short yycheck[] = {     2,
    46,    47,    60,    61,    62,    49,    45,     7,    66,    67,
     7,     7,    56,     4,    58,    45,     7,     7,    48,     0,
     1,    65,     3,     4,     5,     6,     7,   189,     0,    75,
   192,     3,     4,     5,     6,     7,     3,     4,     5,     6,
     7,     3,     4,     5,     6,     7,    46,     7,    45,    46,
    53,     3,     4,     5,     6,     7,    46,   115,   102,   117,
   104,     7,     7,    28,     7,    46,     3,     4,     5,     6,
     7,    36,     7,   119,    46,     6,     7,     7,    45,    46,
     7,     7,     7,    45,    46,     3,     4,     5,     6,     7,
    37,    38,    39,    40,    46,     3,     4,     5,     6,     7,
    45,    37,    38,    39,    40,    41,    42,     4,    45,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
     4,     4,     4,   126,    46,    45,     7,    45,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    45,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,     7,     7,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,     3,     4,     5,     6,
    45,     7,    43,    44,     7,     7,    47,    48,     7,     7,
     4,     7,     7,    45,     7,    45,    45,    45,   191,    45,
    45,   194,     4,     7,    45,    45,    45,    45,    45,    45,
    45,    45,    45,     7,    45,    45,    45,    29,     7,     7,
    45,    45,     7,     7,    45,    45,     0,     2,    45,     2,
    -1,    -1,    -1,    -1,    45,    45,    45,    45,    45,    45,
    45,    -1,    45,    -1,    45,    45,    45,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    68
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/s/bison-1.24/common/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "/s/bison-1.24/common/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 159 "parse.y"
{
	    extern FILE* yyin;
	    if (yyin == stdin)
		cout << "\rClassic> " << flush;
	;
    break;}
case 3:
#line 165 "parse.y"
{ 
	    extern FILE* yyin;
	    extern bool eval;
	    if (yyin == stdin)
		cout << "\rClassic> " << flush;
	;
    break;}
case 18:
#line 192 "parse.y"
{
	    print_object(yyvsp[0].string); free(yyvsp[0].string);
	;
    break;}
case 19:
#line 196 "parse.y"
{ 
	    if (!eval) 
		cout << *(yyvsp[0].individual) << endl;
	;
    break;}
case 20:
#line 201 "parse.y"
{
	    if (!(yyvsp[0].individual))
		cerr << "Null individual.\n";
	    else
		if (!eval) 
		    cout << *(yyvsp[0].individual) << endl;
	;
    break;}
case 21:
#line 209 "parse.y"
{
	    if (!(yyvsp[0].concept))
		cerr << "Null concept.\n";
	    else
		if (!eval)
		    cout << *(yyvsp[0].concept) << endl;
	;
    break;}
case 22:
#line 217 "parse.y"
{
	    if (yyvsp[0].role_fillers) {
		cout << "[ ";
		for (List<Individual*>::iterator i = yyvsp[0].role_fillers->begin();
		    i != yyvsp[0].role_fillers->end(); i++)
		    cout << **i << " ";
		cout << "]\n";
	    }
	;
    break;}
case 23:
#line 227 "parse.y"
{
	    if (concept(yyvsp[-2].string))
		cout << (*concept(yyvsp[-2].string) < *yyvsp[-1].concept? "yes": "no") << endl;
	    else
		if (individual(yyvsp[-2].string))
		    cout << (*individual(yyvsp[-2].string) < *yyvsp[-1].concept? "yes": "no") << endl;
		else
		    cerr << yyvsp[-2].string << " is not a concept or an individual.\n";
	;
    break;}
case 24:
#line 237 "parse.y"
{
	    if (concept(yyvsp[-1].string))
		cout << (*concept(yyvsp[-1].string) < *yyvsp[-2].concept? "yes": "no") << endl;
	    else
		if (individual(yyvsp[-1].string))
		    cout << (*individual(yyvsp[-1].string) < *yyvsp[-2].concept? "yes": "no") << endl;
		else
		    cerr << yyvsp[-1].string << " is not a concept or an individual.\n";
	;
    break;}
case 25:
#line 247 "parse.y"
{
	    if (concept(yyvsp[-2].string))
		cout << (*concept(yyvsp[-2].string) <= *yyvsp[-1].concept? "yes": "no") << endl;
	    else
		cerr << yyvsp[-2].string << " is not a concept.\n";
	;
    break;}
case 26:
#line 254 "parse.y"
{
	    if (concept(yyvsp[-1].string))
		cout << (*concept(yyvsp[-1].string) <= *yyvsp[-2].concept? "yes": "no") << endl;
	    else
		cerr << yyvsp[-1].string << " is not a concept.\n";
	;
    break;}
case 27:
#line 263 "parse.y"
{
	    if (yyvsp[-1].individual) {
		const Set<Concept*>& P = yyvsp[-1].individual->parents();
		cout << "[ ";
		for (Set<Concept*>::const_iterator i = P.begin();
		    i != P.end(); i++)
		    cout << **i << " ";
		cout << "]\n";
	    }
	;
    break;}
case 28:
#line 274 "parse.y"
{
	    if (yyvsp[-1].concept) {
		const Set<Concept*>& P = yyvsp[-1].concept->parents();
		cout << "[ ";
		for (Set<Concept*>::const_iterator i = P.begin();
		    i != P.end(); i++)
		    cout << **i << " ";
		cout << "]\n";
	    }
	;
    break;}
case 29:
#line 287 "parse.y"
{
	    yyval.individual = individual(yyvsp[0].string);
	    if (!yyval.individual)
		cerr << yyvsp[0].string << " is not an individual.\n";
	    free(yyvsp[0].string);
	;
    break;}
case 30:
#line 296 "parse.y"
{   
	    yyval.individual = ind(yyvsp[0].integer);
	;
    break;}
case 31:
#line 300 "parse.y"
{
	    yyval.individual = ind(yyvsp[0].integer);
	;
    break;}
case 32:
#line 304 "parse.y"
{
	    yyval.individual = ind(yyvsp[0].real);
	;
    break;}
case 33:
#line 308 "parse.y"
{
	    yyval.individual = ind(yyvsp[0].string); free(yyvsp[0].string);
	;
    break;}
case 34:
#line 314 "parse.y"
{
	    if (yyvsp[-2].individual)
		yyval.individual = ((ClassicIndividual*)yyvsp[-2].individual)->filler(yyvsp[-1].string); 
	    else
		yyval.individual = 0;
	    free(yyvsp[-1].string);
	;
    break;}
case 35:
#line 322 "parse.y"
{
	    if (yyvsp[-2].role_fillers->size() > yyvsp[-1].integer) {
		List<Individual*>::iterator i = yyvsp[-2].role_fillers->begin();
		for (int j = 0; j < yyvsp[-1].integer; j++)
		    i++;
		yyval.individual = *i;
	    } else
		yyval.individual = 0;
	;
    break;}
case 39:
#line 339 "parse.y"
{
	    if (yyvsp[0].individual)
		fillers.push_back(yyvsp[0].individual);
	;
    break;}
case 40:
#line 344 "parse.y"
{
	    if (yyvsp[0].individual)
		fillers.push_back(yyvsp[0].individual);
	;
    break;}
case 41:
#line 351 "parse.y"
{
	    if (yyvsp[-2].individual) {
		role_fillers = ((ClassicIndividual*)yyvsp[-2].individual)->fillers(yyvsp[-1].string); 
		yyval.role_fillers = &role_fillers;
	    } else
		yyval.role_fillers = 0;
	    free(yyvsp[-1].string);
	;
    break;}
case 42:
#line 362 "parse.y"
{
	    Role* R = role(yyvsp[0].string);
	    if (R)
		roles.push_back(R);
	    free(yyvsp[0].string);
	;
    break;}
case 43:
#line 369 "parse.y"
{
	    Role* R = role(yyvsp[0].string);
	    if (R)
		roles.push_back(R);
	    free(yyvsp[0].string);
	;
    break;}
case 44:
#line 378 "parse.y"
{
	    cout << "Loading " << yyvsp[-1].string << endl;
	    load(yyvsp[-1].string);
	    free(yyvsp[-1].string);
	    /*
		yyparse is restarted after loading, therefore the 
		"lines" rule will not remember to print a prompt.
		Has to be handled very differently, and in parse.l
	     */
	;
    break;}
case 45:
#line 389 "parse.y"
{
	    cout << "Loading " << yyvsp[-1].string << endl;
	    load(yyvsp[-1].string);
	;
    break;}
case 46:
#line 396 "parse.y"
{
	    trace.resume();
	;
    break;}
case 47:
#line 400 "parse.y"
{
	    trace.suspend();
	;
    break;}
case 48:
#line 404 "parse.y"
{
	    trace.set(Trace::classification);
	;
    break;}
case 49:
#line 408 "parse.y"
{
	    trace.set(Trace::subsumption);
	;
    break;}
case 50:
#line 412 "parse.y"
{
	    trace.set(Trace::rule);
	;
    break;}
case 51:
#line 416 "parse.y"
{
	    trace.set(Trace::test);
	;
    break;}
case 52:
#line 420 "parse.y"
{
	    trace.unset(Trace::classification);
	;
    break;}
case 53:
#line 424 "parse.y"
{
	    trace.unset(Trace::rule);
	;
    break;}
case 54:
#line 428 "parse.y"
{
	    trace.unset(Trace::test);
	;
    break;}
case 55:
#line 432 "parse.y"
{
	    trace.unset(Trace::subsumption);
	;
    break;}
case 56:
#line 438 "parse.y"
{
	    define_role(yyvsp[-1].string);
	    if (!eval)
		cout << yyvsp[-1].string << endl;
	    free(yyvsp[-1].string);
	;
    break;}
case 57:
#line 447 "parse.y"
{
	    define_attribute(yyvsp[-1].string);
	    if (!eval)
		cout << yyvsp[-1].string << endl;
	    free(yyvsp[-1].string);
	;
    break;}
case 58:
#line 456 "parse.y"
{
	    define_concept(yyvsp[-2].string, yyvsp[-1].concept);
	    if (!eval)
		cout << yyvsp[-2].string << endl;
	    free(yyvsp[-2].string);
	;
    break;}
case 59:
#line 465 "parse.y"
{
	    define_primitive(yyvsp[-2].string, yyvsp[-1].concept);
	    if (!eval)
		cout << yyvsp[-2].string << endl;
	    free(yyvsp[-2].string);
	;
    break;}
case 60:
#line 474 "parse.y"
{
	    yyval.string = yyvsp[0].string;
	;
    break;}
case 61:
#line 478 "parse.y"
{
	    yyval.string = (char*)malloc(10);
	    sprintf(yyval.string, "%d", yyvsp[0].integer);
	;
    break;}
case 62:
#line 485 "parse.y"
{
	    define_disjoint_primitive(yyvsp[-3].string, yyvsp[-2].concept, yyvsp[-1].string);
	    if (!eval)
		cout << yyvsp[-3].string << endl;
	    free(yyvsp[-3].string);
	    free(yyvsp[-1].string);
	;
    break;}
case 63:
#line 495 "parse.y"
{
	    define_individual(yyvsp[-2].string, yyvsp[-1].concept);
	    if (!eval)
		cout << yyvsp[-2].string << endl;
	    free(yyvsp[-2].string);
	;
    break;}
case 64:
#line 504 "parse.y"
{
	    define_rule(yyvsp[-3].string, yyvsp[-2].concept, yyvsp[-1].concept);
	    if (!eval)
		cout << yyvsp[-3].string << endl;
	    free(yyvsp[-3].string);
	;
    break;}
case 65:
#line 511 "parse.y"
{
	    define_rule(yyvsp[-3].string, yyvsp[-2].concept, yyvsp[-1].computed_concept);
	    if (!eval)
		cout << yyvsp[-3].string << endl;
	    free(yyvsp[-3].string);
	;
    break;}
case 66:
#line 518 "parse.y"
{
	    define_rule(yyvsp[-3].string, yyvsp[-2].concept, yyvsp[-1].computed_fillers);
	    if (!eval)
		cout << yyvsp[-3].string << endl;
	    free(yyvsp[-3].string);
	;
    break;}
case 67:
#line 527 "parse.y"
{
	    ClassicIndividual* I = (ClassicIndividual*)yyvsp[-2].individual;
	    if (I) {
		for (List<Role*>::iterator r = roles.begin(); 
		    r != roles.end(); ) {
		    RoleRestriction* RR = I->role_restriction(*r);
		    if (!RR) {
			cout << "Undefined role " << **r << endl;
			r++;
		    } else
			/*
			    Here is an optimization.  RR->close is called for
			    all roles except the last.  For the last role, 
			    I->close_role() is called.  The former function
			    does not call classify().  The latter does.  And
			    classify() only need be called once.
			 */
			if (++r == roles.end())
			    I->close_role(RR->role());
			else
			    I->close_role_aux(RR->role());
		}
	    }
	    while (roles.size())
		roles.pop_front();
	;
    break;}
case 68:
#line 556 "parse.y"
{
	    cout << *yyvsp[-1].individual << endl;
	;
    break;}
case 69:
#line 562 "parse.y"
{
	    yyval.concept = yyvsp[0].concept;
	;
    break;}
case 70:
#line 566 "parse.y"
{
	    yyval.concept = yyvsp[0].concept;
	;
    break;}
case 71:
#line 572 "parse.y"
{
	    yyval.concept = concept(yyvsp[0].string);
	    if (!yyval.concept)
		cerr << yyvsp[0].string << " is not a concept.\n";
	    free(yyvsp[0].string);
	;
    break;}
case 72:
#line 581 "parse.y"
{
	    and_n++;
	    assert(and_n <= MAX_AND);
	;
    break;}
case 73:
#line 586 "parse.y"
{
	    assert(and_n);
	    and_n--;
	    yyval.concept = and(and_expr[and_n]);
	    while (and_expr[and_n].size())
		and_expr[and_n].pop_front();
	;
    break;}
case 74:
#line 594 "parse.y"
{
	    yyval.concept = all(role(yyvsp[-2].string), yyvsp[-1].concept); free(yyvsp[-2].string);
	;
    break;}
case 75:
#line 598 "parse.y"
{
	    yyval.concept = at_most(yyvsp[-2].integer, role(yyvsp[-1].string)); free(yyvsp[-1].string);
	;
    break;}
case 76:
#line 602 "parse.y"
{
	    yyval.concept = at_least(yyvsp[-2].integer, role(yyvsp[-1].string)); free(yyvsp[-1].string);
	;
    break;}
case 77:
#line 606 "parse.y"
{
	    yyval.concept = exactly(yyvsp[-2].integer, role(yyvsp[-1].string)); free(yyvsp[-1].string);
	;
    break;}
case 78:
#line 610 "parse.y"
{
	    yyval.concept = between(yyvsp[-3].integer, yyvsp[-2].integer, role(yyvsp[-1].string)); free(yyvsp[-1].string);
	;
    break;}
case 79:
#line 614 "parse.y"
{
	    yyval.concept = fills(role(yyvsp[-2].string), fillers);
	    while (fillers.size())
		fillers.pop_front();
	    free(yyvsp[-2].string);
	;
    break;}
case 80:
#line 621 "parse.y"
{
	    yyval.concept = one_of(fillers);
	    while (fillers.size())
		fillers.pop_front();
	;
    break;}
case 81:
#line 627 "parse.y"
{
	    yyval.concept = test_c(yyvsp[-2].string, objects);
	    while (objects.size())
		objects.pop_back();
	    free(yyvsp[-2].string);
	;
    break;}
case 82:
#line 636 "parse.y"
{
	    if (yyvsp[0].concept) 
		and_expr[and_n-1].push_back(yyvsp[0].concept);
	;
    break;}
case 83:
#line 641 "parse.y"
{
	    if (yyvsp[0].concept) 
		and_expr[and_n-1].push_back(yyvsp[0].concept);
	;
    break;}
case 84:
#line 647 "parse.y"
{
	    yyval.computed_concept = computed_concept(yyvsp[-2].string, objects);
	    while (objects.size())
		objects.pop_back();
	    free(yyvsp[-2].string);
	;
    break;}
case 85:
#line 656 "parse.y"
{
	    yyval.computed_fillers = computed_fillers(yyvsp[-3].string, role(yyvsp[-2].string), objects);
	    while (objects.size())
		objects.pop_back();
	    free(yyvsp[-3].string); free(yyvsp[-2].string);
	;
    break;}
case 86:
#line 665 "parse.y"
{
	    Object* obj = object(yyvsp[0].string);
	    if (obj)
		yyval.object = obj;
	    else
		cerr << "no such object\n";
	    free(yyvsp[0].string);
	;
    break;}
case 87:
#line 674 "parse.y"
{
	    yyval.object = yyvsp[0].individual;
	;
    break;}
case 89:
#line 681 "parse.y"
{
	    if (yyvsp[0].object)
		objects.push_back(yyvsp[0].object);
	;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "/s/bison-1.24/common/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 687 "parse.y"


int yyerror(char* s)
{
    cerr << s << " line " << lineno[include_stack_ptr] << endl;
    return 0;
}
